class Sensor{

    constructor(data) {

      //console.log(data); // DEBUG

      this._id = data.id;
      this._name = data.name;
      this._type = data.type;
      this._err = null;

      this._data = data.data;

      if(data.data.values === undefined) {
          //this._values = data.data.value;
      }
      else {
          //this._values = data.data.values;
      }

      try {

        if(this._id === undefined) {
          throw "Erreur : (class Sensor) L'attribut _id n'est pas défini";
        }

        if(this._name === undefined) {
          throw "Erreur : (class Sensor) L'attribut _name n'est pas défini";
        }

        if(this._type === undefined) {
          throw "Erreur : (class Sensor) L'attribut _type n'est pas défini ou le type defini n'est pas <TEMPERATURE>";
        }
      }
      catch(err) {
        this._err = err;
      }
    }

    get id() {
      return this._id;
    }

    get name() {
      return this._name;
    }

    get type() {
      return this._type;
    }

    get value() {
      return this._data.values;
    }

    get lastValue() {

      if(typeof this._data.values === 'object' && this._data.values.length === 1) {
        return this._data.values;
      }
      else if(typeof this._data.values === 'string') {
        return this._data.values;
      }
      else if(typeof this._data.values === 'number') {
        return this._data.values;
      }
      else {
        return this._data.values[this._data.values.length-1];
      }
    }

    get lastDate() {
      if(typeof this._data.labels === 'object' && this._data.labels instanceof Date) {
        return this._data.labels.toLocaleString('fr-FR', { timeZone: 'Europe/Paris' });
      }
      else {
        return this._data.labels[this._data.labels.length-1].toLocaleString('fr-FR', { timeZone: 'Europe/Paris' });
      }
    }

    get labels() {
      return this._data.labels;
    }
}

export default Sensor
